#include <iostream>
#include <iomanip>
#include <cstdio>

#include <cassert>
#include <cmath>
#include <algorithm>

#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <bitset>
#include <queue>

using std::cin;
using std::cout;
using std::cerr;

using std::min;
using std::max;
using std::abs;

using std::vector;
using std::pair;
using std::set;
using std::map;
using std::queue;
using std::bitset;
using std::string;

#define ff first
#define ss second
#define pb push_back
#define print(a) cerr << (a) << '\n'
#define dbg(a) cerr << #a << " = " << (a) << '\n'
#define dbg2(a, b) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << '\n'
#define dbg3(a, b, c) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << '\n'
#define dbg4(a, b, c, d) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << '\n'
#define dbg5(a, b, c, d, e) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << ' ' << #e << " = " << (e) << '\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void init() {
	std::iostream::sync_with_stdio(0);
	cout << std::fixed << std::setprecision(10);
	cerr << std::fixed << std::setprecision(10);
	srand(time(0));
}

int dist(const string & s, const string & t) {
    int n = s.length();
    int res = 0;
    for (int i = 0; i < n; ++i)
        res += (s[i] != t[i]);
    return res;
}

int main() {
	init();

	int n, m, k;
	cin >> n >> m >> k;
	string s, t;
	cin >> s >> t;

    map<string, int> cnt;
    for (int i = 0; i < m; ++i) {
        string cur = "";
        for (int j = i; j < m; ++j) {
            cur += t[j];
            ++cnt[cur];
        }
    }
    int ans = cnt[s];
    for (auto i : cnt) {
        string pot = i.ff;
        if (pot.length() == n && ans < i.ss && dist(pot, s) <= k)
            ans = i.ss;
    }

    cout << ans << '\n';


	return 0;
}


