#include <iostream>
#include <iomanip>
#include <cstdio>

#include <cassert>
#include <cmath>
#include <algorithm>

#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <bitset>
#include <queue>

using std::cin;
using std::cout;
using std::cerr;

using std::min;
using std::max;
using std::abs;

using std::vector;
using std::pair;
using std::set;
using std::map;
using std::queue;
using std::bitset;
using std::string;

#define ff first
#define ss second
#define pb push_back
#define print(a) cerr << (a) << '\n'
#define dbg(a) cerr << #a << " = " << (a) << '\n'
#define dbg2(a, b) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << '\n'
#define dbg3(a, b, c) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << '\n'
#define dbg4(a, b, c, d) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << '\n'
#define dbg5(a, b, c, d, e) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << ' ' << #e << " = " << (e) << '\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void init() {
	std::iostream::sync_with_stdio(0);
	cout << std::fixed << std::setprecision(10);
	cerr << std::fixed << std::setprecision(10);
	srand(time(0));
}

bool comp1(const pll & a, const pll & b) {
    return a.ff - a.ss < b.ff - b.ss;
}

bool comp2(const pll & a, const pll & b) {
    return a.ff > b.ff;
}

bool comp3(const pll & a, const pll & b) {
    return a.ff + a.ss > b.ff + b.ss;
}

bool comp4(const pll & a, const pll & b) {
    return a.ff < b.ff;
}

int main() {
	init();

    int n;
    cin >> n;
    vector<pll> pl, mn;
    int zero = 0;
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        if (a == 0 && b > 0) ++zero;
        else (a > 0 ? pl : mn).pb({a, b});
    }
    int a = pl.size(), b = mn.size();
    int ans = zero;
    { // plus first
        sort(pl.begin(), pl.end(), comp1);
        sort(mn.begin(), mn.end(), comp2);
        vector<ll> can(b + 1);
        can[0] = 0;
        for (int i = 0; i < b; ++i) {
            can[i + 1] = can[i] + (mn[i].ff + mn[i].ss > 0);
        }
        /*
        print("pl:");
        for (auto i : pl) dbg2(i.ff, i.ss);
        print("mn:");
        for (auto i : mn) dbg2(i.ff, i.ss);
        print("can:");
        for (auto i : can) print(i);
        */
        for (int i = 0; i < a; ++i) {
            if (pl[i].ff - pl[i].ss >= 0) break;
            int l = -1, r = b;
            while (r - l > 1) {
                int m = (l + r) >> 1;
                //dbg5(l, r, m, mn[m].ff * 2, pl[i].ff - pl[i].ss);
                if (mn[m].ff * 2 > pl[i].ff - pl[i].ss)
                    l = m;
                else
                    r = m;
            }
            ++l;
            int pot = can[l] + i + zero + 1;
            //dbg5(i, l, can[l], zero, pot);
            if (pot % 2 == 0)
                --pot;
            ans = max(ans, pot);
        }
    }
    { // minus first
        sort(mn.begin(), mn.end(), comp3);
        sort(pl.begin(), pl.end(), comp4);
        vector<ll> can(a + 1);
        can[0] = 0;
        for (int i = 0; i < a; ++i) {
            can[i + 1] = can[i] + (pl[i].ff - pl[i].ss < 0);
        }
         /*
        print("pl:");
        for (auto i : pl) dbg2(i.ff, i.ss);
        print("mn:");
        for (auto i : mn) dbg2(i.ff, i.ss);
        print("can:");
        for (auto i : can) print(i);
         */
        for (int i = 0; i < b; ++i) {
            if (mn[i].ff + mn[i].ss <= 0) break;
            int l = -1, r = a;
            while (r - l > 1) {
                int m = (l + r) >> 1;
               //dbg5(l, r, m, mn[m].ff * 2, pl[i].ff - pl[i].ss);
                if (pl[m].ff * 2 < mn[i].ff + mn[i].ss)
                    l = m;
                else
                    r = m;
            }
            ++l;
            int pot = can[l] + i + zero + 1;
            if (pot % 2 == 0)
                --pot;
            //dbg5(i, l, can[l], zero, pot);
            ans = max(ans, pot);
        }
    }

    cout << ans << '\n';


	return 0;
}


