#include <iostream>
#include <cstdlib>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <array>
#include <algorithm>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = (1 << 29) + 5;
const ll LLINF = (1ll << 59) + 7;
const int MOD = 1000*1000*1000 + 7;
const int MAX_N = 200*1000;

struct point
{
    ll x;
    ll time;

    point()
    {

    }

    point(ll _x, ll _time)
    {
        x = _x;
        time = _time;
    }
};

bool cmp1(const point &a, const point &b)
{
    return a.x < b.x;
}

bool operator<(const point &a, const point &b)
{
    return a.time < b.time;
}

int n;
vector<point> arr1;
vector<point> arr2;
point arr[MAX_N];
set<ll> ff;

int solve(vector<point> &g1, vector<point> &g2)
{
    ff.clear();
    int answer = 0;
    for (int i = 0; i < g1.size(); ++i)
    {
        ff.insert(g1[i].time - g1[i].x);
    }

    while (!ff.empty() && (*ff.begin()) <= 0)
    {
        ff.erase(ff.begin());
    }
    answer = ff.size();
    int delta = 0;
    int cur_add = 0;
    for (int i = 0; i < g2.size(); ++i)
    {
        delta = max((ll)delta, g2[i].x);
        if (g2[i].x < g2[i].time)
        {
            ++cur_add;
        }
        while (!ff.empty() && (*ff.begin()) - 2*delta <= 0)
        {
            ff.erase(ff.begin());
        }
        answer = max(answer, (int)ff.size() + cur_add);
    }

    return answer;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    scanf("%d", &n);
    int answer = 0;
    for (int i = 0; i < n; ++i)
    {
        scanf("%I64d %I64d", &arr[i].x, &arr[i].time);
        if (arr[i].x > 0)
        {
            arr1.push_back(arr[i]);
        }
        else if (arr[i].x < 0)
        {
            arr[i].x = -arr[i].x;
            arr2.push_back(arr[i]);
        }
        else if (arr[i].time != 0)
        {
            ++answer;
        }
    }

    sort(arr1.begin(), arr1.end(), cmp1);
    sort(arr2.begin(), arr2.end(), cmp1);

    int add_ans;
    add_ans = solve(arr1, arr2);
    add_ans = max(add_ans, solve(arr2, arr1));

    if ((answer + add_ans)&1)
    {
        cout << answer + add_ans;
    }
    else
    {
        cout << max(answer + add_ans - 1, 0);
    }

    fclose(stdin);
    fclose(stdout);

    return 0;
}
