#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <iostream>
#include <iostream>
#include <queue>
#include <deque>
#include <stack>
#include <iomanip>

using namespace std;

#define LOCAL 0
#define ll long long
#define mp make_pair
#define pb push_back
#define ppb pop_back

const int INF = (int)1e9;

vector <int> a;

int good(int p, int k)
{
	int cnt = 0,
		lvl = 1;
	for (int i = p; i < (int)a.size(); ++i)
	{
		cnt += a[i];
		if (cnt >= lvl)
		{
			cnt = 0;
			lvl++;
		}
		if (lvl == k)
			return i - p + 1;
	}
	return INF;
}

int main()
{
#if LOCAL == 1
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	
	int n, k;
	cin >> n >> k;
	a.resize(n);

	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	
	int ans = INF;
	for (int i = 0; i < n; ++i)
	{
		int c = good(i, k);
		ans = min(ans, c);
	}

	if (ans == INF)
		ans = -1;
	cout << ans;

	return 0;
}


//#define TREAP
#ifdef TREAP

int get_rand()
{
	return rand() ^ (rand() << 15);
}

struct node
{
	int x;

	int y;

	node* left;
	
	node* right;

	node()
	{
	}

	node(int _x, int _y)
		: x(_x)
		, y(_y)
		, left(NULL)
		, right(NULL)
	{
	}
};

typedef node* p_node;

p_node merge(p_node L, p_node R)
{
	if (L == NULL)
		return R;
	if (R == NULL)
		return L;
	if (L->y > R->y)
	{
		L->right = merge(L->right, R);
		return L;
	}
	else
	{
		R->left = merge(L, R->left);
		return R;
	}
}

// [)

pair <p_node, p_node> split(p_node v, int key)
{
	if (v == NULL)
		return mp((p_node)NULL, (p_node)NULL);

	pair <p_node, p_node> tmp;
	if (v->x >= key)
	{
		tmp = split(v->left, key);
		v->left = tmp.second;
		tmp.second = v;
	}
	else
	{
		tmp = split(v->right, key);
		v->right = tmp.first;
		tmp.first = v;
	}

	return tmp;
}

void print(p_node v)
{
	if (v == NULL)
		return;
	print(v->left);
	cout << v->x << ' ';
	print(v->right);
}

void print_tree(p_node v)
{
	print(v);
	cout << "\n";
}

p_node find(p_node v, int key)
{
	if (v == NULL || v->x == key)
		return v;
	if (v->x > key)
		return find(v->left, key);
	else
		return find(v->right, key);
}

int main()
{
#if LOCAL == 1
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif

	p_node root = NULL;

	for (int i = 1; i <= 10; ++i)
	{
		p_node tmp = new node(i, get_rand());
		root = merge(root, tmp);
		print_tree(root);
	}

	print_tree(root);

	p_node v;

	for (int i = 1; i <= 10; ++i)
	{
		p_node v = find(root, i);
		if (v != NULL)
			cout << v->x << "\n";
	}

	pair <p_node, p_node> tmp = split(root, 6);
	print_tree(tmp.first);
	print_tree(tmp.second);

	return 0;
}

#endif