#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iostream>
#include <vector>
#include <cstring>
#include <numeric>
#include <cassert>
using namespace std;
struct data
{
	int max1, pos1;
	int max2, pos2;
	data()
	{
		max1=0;
		pos1=-1;
		max2=0;
		pos2=-1;
	}
};
data merge(data x, data y)
{
	data ans;
	if(x.max1>y.max1)
	{
		ans.max1=x.max1;
		ans.pos1=x.pos1;
		x.max1=-1;
		x.pos1=-1;
		swap(x.max1,x.max2);
		swap(x.pos1,x.pos2);
	}
	else
	{
		ans.max1=y.max1;
		ans.pos1=y.pos1;
		y.max1=-1;
		y.pos1=-1;
		swap(y.max1,y.max2);
		swap(y.pos1,y.pos2);
	}
	if(x.max1>y.max1)
	{
		ans.max2=x.max1;
		ans.pos2=x.pos1;
		x.max1=-1;
		x.pos1=-1;
		swap(x.max1,x.max2);
		swap(x.pos1,x.pos2);
	}
	else
	{
		ans.max2=y.max1;
		ans.pos2=y.pos1;
		y.max2=-1;
		y.pos2=-1;
		swap(y.max1,y.max2);
		swap(y.pos1,y.pos2);
	}
	return ans;
}
struct segmentTree
{
	vector<data>tree;
	segmentTree(int n)
	{
		tree.resize(4*n+7);
	}
	void change(int v,int tl,int tr,int pos,data val)
	{
		if(tl==tr)
		{
			tree[v]=val;
		}
		else
		{
			int tm=(tl+tr)/2;
			if(pos<=tm)
			{
				change(2*v,tl,tm,pos,val);
			}
			else
			{
				change(2*v+1,tm+1,tr,pos,val);
			}
			tree[v]=merge(tree[2*v],tree[2*v+1]);
		}
	}
	data get(int v,int tl,int tr,int l,int r)
	{
		if(r<tl || l>tr) return data();
		if(tl>=l && tr<=r) return tree[v];
		int tm=(tl+tr)/2;
		return merge(get(2*v,tl,tm,l,r),get(2*v+1,tm+1,tr,l,r));
	}
};
const int MAXN = 1000 * 1000 + 7;
int n;
data pos[MAXN];
int h[MAXN];
int go[MAXN], go2[MAXN][21];
int ans[MAXN];
int dist[MAXN];
int dist2[MAXN];
int calcDist(int v)
{
	if(v==-1) return (int)1e9;
	if(v==n) return 0;
	if(dist[v]!=0) return dist[v];
	dist[v]=calcDist(go[v]) + 1;
	return dist[v];
}
int calcDist2(int v)
{
	if(v==-1) return (int)1e9;
	if(v==n) return 0;
	if(dist2[v]!=0) return dist2[v];
	dist2[v]=calcDist2(go2[v][0]) + 1;
	return dist2[v];
}
int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);	
	scanf("%d %d", &n, &h[0]);
	for(int i =1;i<n;i++)
	{
		scanf("%d", &h[i]);
	}
	for(int i=0;i<n;i++)
	{
		h[i]=min(h[i],n);
	}
	segmentTree st(n);
	for(int i =n - 1;i>=0;i--)
	{
		if(h[i]==n)
		{
			pos[i].max1=n;
			pos[i].max2=n;
			pos[i].pos1=n;
			pos[i].pos2=n;
		}
		else
		{
			pos[i]=st.get(1,1,n,i+1,h[i]);
		}		
		if(i!=0)
		{
			data cur;
			cur.max1=h[i];
			cur.pos1=i;
			cur.max2=-1;
			cur.pos2=-1;
			st.change(1,1,n,i,cur);
		}
	}
	for(int i=0;i<=n;i++)
	{
		if(pos[i].pos1<=i)
		{
			pos[i].pos1=-1;
		}
		if(pos[i].pos2<=i)
		{
			pos[i].pos2=-1;
		}
		go[i]=pos[i].pos1;
		go2[i][0]=pos[i].pos2;
	}	
	for(int i=0;i<n;i++)
	{
		for(int j=2;j<=20;j++)
		{
			if(go2[i][j-1]==-1 || go2[i][j-1]==n)
			{
				go2[i][j]=go2[i][j-1];
			}
			else
			{
				go2[i][j]=go2[go2[i][j-1]][j-1];
			}
		}
	}
	vector<int>path;
	map<int,int>posPath;
	int curPos=0;
	while(1)
	{
		path.push_back(curPos);
		if(curPos==n) break;
		curPos=go[curPos];
		if(curPos==-1)
		{
			break;
		}
	}	
	for(int i=0;i<(int)path.size();i++)
	{
		posPath[path[i]]=i;
	}
	for(int i=0;i<=n;i++)
	{
		calcDist(i);
		calcDist2(i);
	}		
	for(int i=1;i<=n;i++)
	{
		if(!posPath.count(i))
		{
			ans[i]=dist[0] - 1;
			if(ans[i]>=(int)1e9) ans[i]=-1;
		}
		else
		{
			int bad=path[posPath[i] - 1];
			if(pos[bad].pos2 == -1)
			{
				ans[i]=-1;
				continue;
			}
			int bad2=pos[bad].pos2;
			if(dist[bad2]>=(int)1e9)
			{
				ans[i]=-1;
				continue;
			}
			ans[i]+=dist[0]-dist[bad];
			ans[i]+=dist2[bad2];
			for(int j=20;j>=0;j--)
			{
				if(go2[bad2][j] != -1 && pos[go2[bad2][j]].pos1==i)
				{
					bad2=go2[bad2][j];
				}
			}
			if(pos[bad2].pos1==i) bad2=go2[bad2][0];	
			assert(pos[bad2].pos1!=i);
			ans[i]-=dist2[bad2];
			ans[i]+=dist[bad2];		
		}
	}
	for(int i =1;i<n;i++)
	{
		if(ans[i]>=(int)1e9) ans[i]=-1;
		printf("%d ", ans[i]);
	}
	printf("\n");
}